////////////// devel console
//function console(text){
//    setTimeout(function(){
//        if(Firebug){
//            if(Firebug.Console){
//                Firebug.Console.log(text);
//            }
//        }
//    },3000);
//
//}
////////////// devel console

var a00115prefs = {
    removeLocation:function()
    {
        var locationList = document.getElementById("BlockedWebsitesList");
		
        locationList.removeItemAt(locationList.selectedIndex);
    },
    removeAllLocations:function()
    {
        var locationList = document.getElementById("BlockedWebsitesList");
		
        while(locationList.getRowCount())
        {
            locationList.removeItemAt(0);
        }
    },
    addLocation:function()
    {
        
        var locationList = window.opener.document.getElementById("BlockedWebsitesList");
        
        var newLocation = document.getElementById("blockSiteNewLocation").value
        if(this.isURL(newLocation)){
            newLocation=newLocation.toLowerCase();
            newLocation=this.cropUrl(newLocation);
            for(var i=0;i<locationList.itemCount;i++){
                if(locationList.getItemAtIndex(i).label==newLocation 
                    || "www." + locationList.getItemAtIndex(i).label==newLocation
                    || locationList.getItemAtIndex(i).label=="www."+newLocation) {
                    document.getElementById('pageExist').setAttribute('style', 'display:block');
                    return;
                } 
            }
            
            if(newLocation){
                
                locationList.appendItem(newLocation);
            }
        }
    },
    isURL:function(url) {

        var RegExp = /^(([\w]+:)?\/\/)?(([\d\w]|%[a-fA-f\d]{2,2})+(:([\d\w]|%[a-fA-f\d]{2,2})+)?@)?([\d\w][-\d\w]{0,253}[\d\w]\.)+[\w]{2,4}(:[\d]+)?(\/([-+_~.\d\w]|%[a-fA-f\d]{2,2})*)*(\?(&?([-+_~.\d\w]|%[a-fA-f\d]{2,2})=?)*)?(#([-+_~.\d\w]|%[a-fA-f\d]{2,2})*)?$/; 
        if(RegExp.test(url)){ 
            return true; 
        }else{ 
            return false; 
        } 
    },
    //Initialize options
    initializeOptions:function()
    {
        
        sizeToContent();

        var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");
		var statPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.wips.stats_permission.");

        document.getElementById("autocopyPasteOnMiddleClick").checked = autocopyPrefs.getBoolPref("optPasteOnMiddleClick");
        document.getElementById("autocopyDeselectAfterCopy").checked = autocopyPrefs.getBoolPref("optDeselectAfterCopy");
        document.getElementById("autocopyStatusBarButton").checked = autocopyPrefs.getBoolPref("optStatusBar");
        document.getElementById("autocopyEditMenuItem").checked = autocopyPrefs.getBoolPref("optEditMenuItem");
        document.getElementById("autocopyContextMenuItem").checked = autocopyPrefs.getBoolPref("optContextMenuItem");
        document.getElementById("autocopyEnableInTextBoxes").checked = autocopyPrefs.getBoolPref("optEnableInTextBoxes");
        document.getElementById("autocopyCopyWithoutFormating").checked = autocopyPrefs.getBoolPref("optCopyWithoutFormating");
        document.getElementById("autocopyStatusbarBlink").checked = autocopyPrefs.getBoolPref("optStatusbarBlink");
        document.getElementById("autocopyContextMenu").checked = autocopyPrefs.getBoolPref("optContextMenu");
        document.getElementById("autocopyContextMenuHideTimeout").value = autocopyPrefs.getIntPref("optContextMenuHideTimeout");

        document.getElementById("autocopyKeyboardShortcutEnabled").checked = autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled");

        document.getElementById("autocopyKeyboardShortcutKeyAccel").checked = autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAccel");
        document.getElementById("autocopyKeyboardShortcutKeyMeta").checked = autocopyPrefs.getBoolPref("optKeyboardShortcutKeyMeta");
        document.getElementById("autocopyKeyboardShortcutKeyCtrl").checked = autocopyPrefs.getBoolPref("optKeyboardShortcutKeyCtrl");
        document.getElementById("autocopyKeyboardShortcutKeyShift").checked = autocopyPrefs.getBoolPref("optKeyboardShortcutKeyShift");
        document.getElementById("autocopyKeyboardShortcutKeyAlt").checked = autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAlt");
        document.getElementById("autocopyKeyboardShortcutKey").value = autocopyPrefs.getCharPref("optKeyboardShortcutKey");
		document.getElementById("autocopyStats").checked = statPrefs.getBoolPref("a00115");

        if(navigator.userAgent.match(/Firefox/i))
        {
            document.getElementById("autocopyEditMenuItem").setAttribute("hidden", false);
            document.getElementById("autocopyContextMenuItem").setAttribute("hidden", false);
        }
        else
        {
            document.getElementById("autocopyEditMenuItem").setAttribute("hidden", true);
            document.getElementById("autocopyContextMenuItem").setAttribute("hidden", true);
        }
        
        // Read BlockSite.locations
        var blockedWebsitesString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	
        if(autocopyPrefs.prefHasUserValue("locations"))
        {
            blockedWebsitesString = autocopyPrefs.getComplexValue("locations", Components.interfaces.nsISupportsString).data;
            var blockedWebsitesArray = blockedWebsitesString.split("|||");
        }
        else
        {
            var blockedWebsitesArray = new Array();
        }
        
	
        var locationList = document.getElementById("BlockedWebsitesList");
		
        for(var i=0; i < blockedWebsitesArray.length; i++)
        {
            if(blockedWebsitesArray[i] != "")
            {
                locationList.appendItem(blockedWebsitesArray[i]);
            }
        }
        
        
    },
    initSetWebsite:function(){
        //$('#pageExist').hide();
        document.getElementById('pageExist').setAttribute('style', 'display:none;color:red');
    },
    saveOptions: function()
    {
        var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");
		var statPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.wips.stats_permission.");				


        autocopyPrefs.setBoolPref("optPasteOnMiddleClick", document.getElementById("autocopyPasteOnMiddleClick").checked);
        autocopyPrefs.setBoolPref("optDeselectAfterCopy", document.getElementById("autocopyDeselectAfterCopy").checked);
        autocopyPrefs.setBoolPref("optStatusBar", document.getElementById("autocopyStatusBarButton").checked);
        autocopyPrefs.setBoolPref("optEditMenuItem", document.getElementById("autocopyEditMenuItem").checked);
        autocopyPrefs.setBoolPref("optContextMenuItem", document.getElementById("autocopyContextMenuItem").checked);
        autocopyPrefs.setBoolPref("optEnableInTextBoxes", document.getElementById("autocopyEnableInTextBoxes").checked);
        autocopyPrefs.setBoolPref("optCopyWithoutFormating", document.getElementById("autocopyCopyWithoutFormating").checked);
        autocopyPrefs.setBoolPref("optStatusbarBlink", document.getElementById("autocopyStatusbarBlink").checked);
        autocopyPrefs.setBoolPref("optContextMenu", document.getElementById("autocopyContextMenu").checked);
        autocopyPrefs.setIntPref("optContextMenuHideTimeout", document.getElementById("autocopyContextMenuHideTimeout").value);


        autocopyPrefs.setBoolPref("optKeyboardShortcutEnabled", document.getElementById("autocopyKeyboardShortcutEnabled").checked);

        autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAccel", document.getElementById("autocopyKeyboardShortcutKeyAccel").checked);
        autocopyPrefs.setBoolPref("optKeyboardShortcutKeyMeta", document.getElementById("autocopyKeyboardShortcutKeyMeta").checked);
        autocopyPrefs.setBoolPref("optKeyboardShortcutKeyCtrl", document.getElementById("autocopyKeyboardShortcutKeyCtrl").checked);
        autocopyPrefs.setBoolPref("optKeyboardShortcutKeyShift", document.getElementById("autocopyKeyboardShortcutKeyShift").checked);
        autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAlt", document.getElementById("autocopyKeyboardShortcutKeyAlt").checked);
        autocopyPrefs.setCharPref("optKeyboardShortcutKey", document.getElementById("autocopyKeyboardShortcutKey").value);
		statPrefs.setBoolPref("a00115",document.getElementById("autocopyStats").checked);
        
        // Store BlockSite.locations
        var locationList = document.getElementById("BlockedWebsitesList");
        var locationCount = locationList.getRowCount();
        var locationArray = new Array();
        var locationNsIString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        for(var i=0; i < locationCount; i++)
        {
            locationArray.push(locationList.getItemAtIndex(i).label);
        }
        locationNsIString.data = locationArray.join("|||");
        autocopyPrefs.setComplexValue("locations", Components.interfaces.nsISupportsString, locationNsIString);

    },
    validateContextTimeout:function()
    {
        eliment = document.getElementById("autocopyContextMenuHideTimeout");
        if (isNaN(parseInt(eliment.value)) || eliment.value < 0 )
            return false;      
        else
            //return valid      
            return true;
    },
    cropUrl: function(url){
        url=url.replace("www.","");
        url=url.replace("http:\/\/","");
        url=url.replace("https:\/\/","");
        var array = url.split('/');
        return array[0];
    }
}
