// CONFIG (spolecny)
WIPS.a00115.config.apiUrl = 'https://api.wips.com/';

//////////////// OBECNE FCE ////////////////
WIPS.a00115.elmID = function(element){
    return document.getElementById(element);
}
WIPS.a00115.getActualTime = function(){
    var time = new Date();
    return time.getTime();
}
//////////////// HLAVNI OBJEKT WIPS ////////////////

WIPS.a00115.C = {
    "client_guid": "extensions.wips.client",
    "stats": "extensions.wips.stats_permission.a00115",
    "extension_id": "extensions.wips.extension_id.a00115",
    "install_date": "extensions.wips.preferences.a00115.install_date",
    "version": "extensions.wips.preferences.a00115.version",
    "stats_lock": "extensions.wips.stats.lock",
    "currentFalseUrl": "extensions.wips.stats.current_false_url",
    "lastFalseUrl": "extensions.wips.stats.last_false_url",
    "stats_reg_lock": "extensions.wips.stats.reglock",
    "every_url_lock": "extensions.wips.stats.every_url_lock",    
    "check_id_timeout": "extensions.wips.check_id_timeout",
    "enabled": "extensions.wips.preferences.a00115.enabled",
    "download": "extensions.wips.preferences.a00115.download",
    "native": "extensions.wips.preferences.a00115.native"
};

WIPS.a00115.prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

WIPS.a00115.wips = {
    config: WIPS.a00115.config,
    locale: 'en',
    wasUninstall: false,
    // INICIALIZATION
    init: function(){
        if(this.getPref(WIPS.a00115.C.client_guid,"char") == "x"){//prvni spusteni
            try{
                WIPS.a00115.wipstats.register();
            }catch(e){}
        }
        setTimeout(function(){
            if(WIPS.a00115.wips.getPref(WIPS.a00115.C.client_guid,"char") != "x"){
                WIPS.a00115.wipstats.checkId();
            }
        },10000);
        if(this.getPref(WIPS.a00115.C.client_guid,"char") != "x"){
            if(!this.getPref(WIPS.a00115.C.extension_id,"bool") || this.getPref(WIPS.a00115.C.version,"char")!=this.config.version){
                this.setPref(WIPS.a00115.C.version,this.config.version,"char");
                setTimeout(function(){
                    WIPS.a00115.wipstats.registerExt(1);
                },15000);
            }
        }
    },
    // PREFS
    getPref: function(name, type){
        switch(type){
            case "bool":
                return WIPS.a00115.prefService.getBoolPref(name);
                break;
            default:
            case "char":
                return WIPS.a00115.prefService.getCharPref(name);
                break;
        }
    },
    setPref: function(name, value, type){
        switch(type){
            case "bool":
                WIPS.a00115.prefService.setBoolPref(name,value);
                break;
            default:
            case "char":
                WIPS.a00115.prefService.setCharPref(name,value);
                break;
        }
    },
    // OTHERS
    guidGenerator: function(){
        var S4 = function() {
            return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
        }
        return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
    },
    openURL: function(url){
        openUILinkIn(url,"current");
    }
}

//////////////// POSLUCHACE ////////////////
window.addEventListener("load", function(){
    WIPS.a00115.wips.init();
}, false);

WIPS.a00115.uninstallListener = {
    onUninstalling: function(addon){
        if(addon.id == "{0FED7D55-65D4-47b6-A6DE-9A4ADB55355F}"){
            setTimeout(function(){
                if(!WIPS.a00115.wips.wasUninstall){
                    WIPS.a00115.wips.wasUninstall = true;
                    //openUILinkIn(WIPS.a00115.config.uninstallPage,"tab");
                    WIPS.a00115.wipstats.registerExt(0);
                }
            },Math.floor((Math.random()*300)+1));
        }
    }
}